/* Andrei Parvu
   O(M * max(M[1], M[2], ..., M[9]))
*/

#include <cstdio>
#include <cstring>
#include <algorithm>

using namespace std;

#define NR_DIGITS 10
#define LDIGIT 1
#define HDIGIT 9
#define LMAX 10000
#define MMAX 10000

const int INF = 0x3f3f3f;
const int MOD = 30313;

int countd[NR_DIGITS], M[NR_DIGITS];
int P[NR_DIGITS][MMAX + 5];
char sir[LMAX];
int fact[MMAX + 5];

int main() {
  freopen("cifru.in", "rt", stdin);
  freopen("cifru.out", "wt", stdout);

  int n;

  memset(M, 0x3f, sizeof(M));

  scanf("%d\n", &n);
  for (int i = 0; i < n; i++) {
    scanf("%s\n", sir);

    int nr = strlen(sir);
    for (int j = 0; j < nr; j++) {
      countd[sir[j] - '0']++;
    }

    for (int j = LDIGIT; j <= HDIGIT; j++) {
      M[j] = min(M[j], countd[j]);
      countd[j] = 0;
    }
  }

  int cnt = 0; // = M
  P[0][0] = 1;
  for (int i = LDIGIT; i <= HDIGIT; i++) {
    P[i][0] = 1;
    if (M[i] != INF) {
      cnt += M[i];
    } else {
      M[i] = 0;
    }
  }

  fact[0] = 1;
  for (int i = 1; i <= cnt; i++) {
    fact[i] = (fact[i - 1] * i) % MOD;
  }

  for (int i = LDIGIT; i <= HDIGIT; i++) {
    for (int j = 1; j <= cnt; j++) {
      int prod = 1;
      for (int p = 0; p <= min(M[i], j); p++) {
        P[i][j] += P[i - 1][j - p] * prod;
        P[i][j] %= MOD;

        prod *= (M[i] - p);
        prod %= MOD;
      }
    }
  }

  int num = 1;
  for (int i = LDIGIT; i <= HDIGIT; i++) {
    num *= fact[M[i]];
    num %= MOD;
  }

  int aux = num;
  for (int i = 2; i <= MOD - 2; i++) {
    num *= aux;
    num %= MOD;
  }

  int rez = 0;
  for (int i = 0; i < cnt; i++) {
    int aux = (fact[cnt - i] * P[HDIGIT][i]) % MOD;

    rez = (rez + aux * num) % MOD;
  }

  printf("%d\n", rez);

  return 0;
}

