//Dragos Oprica - Combinari smechere

#include <fstream>
#include <iostream>
#include <algorithm>
using namespace std;
 
ifstream fin ("maxmaxmax.in"); 
ofstream fout ("maxmaxmax.out"); 

const long long MOD=1114111LL;

long long fact[MOD];
long long N,X,Y;

inline bool check (long long N,long long K) {
	long long ret=0;

	for (long long i=N; i; i/=MOD)
		ret+=i;
	for (long long i=K; i; i/=MOD)
		ret-=i;
	for (long long i=N-K; i; i/=MOD)
		ret-=i;

	return (ret<=0);
}

inline long long value (long long N) {
	long long ret=1;

	while (N) {
		ret=(ret*fact[N%MOD])%MOD;
		N/=MOD;
	}

	return ret;
}

inline long long euclid (long long a,long long b,long long &x,long long &y) {
	long long d,x0,y0;
	
	if (!b)
    {
        x=1; y=0;
        return a;
    }
    d=euclid (b,a%b,x0,y0);
    x=y0; y=x0-(a/b)*y0;
 
    return d;
}

inline long long invers (long long N) {
    long long inv,nr;
    
    N%=MOD;
    euclid (N,MOD,inv,nr);
	if (inv<0)
		inv=MOD+inv%MOD;

	return inv;
}

inline long long combinations (long long N,long long K) {
	if (!check (N,K))
		return 0;
					
	return (((value (N)*invers (value (K)))%MOD)*invers (value (N-K)))%MOD;
}                                                           

void preprocess () {
	fact[0]=1;
	for (long long i=1; i<MOD; ++i)
		fact[i]=(i*fact[i-1])%MOD;
}

int main () {	
    preprocess ();
	fin>>N>>X>>Y;

	if (N%3==0) {
        if (N/3<Y-X+1)
			fout<<combinations (N+(Y-X+1)-(N/3),N);
		else
			fout<<combinations (Y-X+1,N%(Y-X+1));
	}
	else if (N%3==1) {
        if (N/3<Y-X+1) {
			if (N<(Y-X+1)-N/3)
				fout<<((((N/3)%MOD)*combinations (N+(Y-X+1)-(N/3),N))%MOD+((((N/3)*(N/3+1)/2)%MOD)*combinations (N+(Y-X+1)-(N/3+1),N))%MOD)%MOD;
			else
				fout<<((((N/3)%MOD)*combinations (N+(Y-X+1)-(N/3),(Y-X+1)-(N/3)))%MOD+((((N/3)*(N/3+1)/2)%MOD)*combinations (N+(Y-X+1)-(N/3)-1,(Y-X+1)-(N/3+1)))%MOD)%MOD;
		}
		else
			fout<<combinations (Y-X+1,N%(Y-X+1));

	}
	else {          
        if (N/3<Y-X+1)
			fout<<((N/3+1)*combinations (N+(Y-X+1)-(N/3+1),N))%MOD;
		else
			fout<<combinations (Y-X+1,N%(Y-X+1));
	}

	return 0;
}
