#include <cassert>

#include <algorithm>
#include <deque>
#include <fstream>
#include <iostream>
#include <stack>
#include <vector>
using namespace std;

#define FORIT(it, v) for (typeof((v).begin()) it = (v).begin(); it != (v).end(); ++it)

ifstream fin("tower8.in");
ofstream fout("tower8.out");

const int MAX_N = 100;

int n, m;
int a[MAX_N + 1][MAX_N + 1];

void read() {
    fin >> n >> m;
    assert(1 <= n && n <= MAX_N);
    assert(1 <= m && m <= MAX_N);

    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= m; ++j) {
            fin >> a[i][j];
            assert(1 <= a[i][j] && a[i][j] <= 9);
        }
}

inline bool valid_pos(int x, int y) {
    return ((1 <= x && x <= n) && (1 <= y && y <= m));
}

inline bool distinct_pos(int x1, int y1, int x2, int y2) {
    return (x1 != x2) || (y1 != y2);
}

bool put_val(int x, int y, int val, int init_val, bool get_moves, vector< pair<int, int> > &moves) {
    if (a[x][y]) return false;

    if (val == 1) {
        /*if (init_val == 1)
            for (int i = -1; i <= 1; ++i)
                for (int j = -1; j <= 1; ++j) {
                    int xx = x + i;
                    int yy = y + j;
                    if (valid_pos(xx, yy) && distinct_pos(x, y, xx, yy))
                        if (a[xx][yy] == 1)
                            return false;
                }
*/
        a[x][y] = val;
        if (get_moves)
            moves.push_back(make_pair(x, y));
        return true;
    }

    for (int i = -1; i <= 1; ++i)
        for (int j = -1; j <= 1; ++j) {
            int xx = x + i;
            int yy = y + j;
            if (valid_pos(xx, yy) && distinct_pos(x, y, xx, yy)) {
                vector< pair<int, int> > neighbour_moves;
                if (put_val(xx, yy, val - 1, init_val - 1, get_moves, neighbour_moves)) {
                    vector< pair<int, int> > cell_moves;
                    if (put_val(x, y, val - 1, init_val, get_moves, cell_moves)) {
                        a[x][y] = val;
                        a[xx][yy] = 0;

                        if (get_moves) {
                            FORIT(it, neighbour_moves)
                                moves.push_back(*it);
                            FORIT(it, cell_moves)
                                moves.push_back(*it);
                        }

                        return true;
                    } else {
                        a[xx][yy] = 0;
                    }
                }
            }
        }

    a[x][y] = 0;
    return false;
}

struct Move {
    int x, y, digit;

    Move() : x(0), y(0), digit(0) {}

    Move(int x, int y, int digit) {
        this->x = x;
        this->y = y;
        this->digit = digit;
    }
};

void solve() {
    stack<Move> moves;

    int step_no = 0;
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= m; ++j)
            step_no += (1 << (a[i][j] - 1));
    fout << step_no << "\n";

    for (int digit = 1; digit <= 9; ++digit) {
        // build deque with positions
        deque< pair<int, int> > d;
        for (int i = 1; i <= n; ++i)
            for (int j = 1; j <= m; ++j)
                if (a[i][j] == digit)
                    d.push_back(make_pair(i, j));
        
        while (!d.empty()) {
            pair<int, int> pos = d.front();
            d.pop_front();

            int x = pos.first;
            int y = pos.second;

            a[x][y] = 0;
            vector< pair<int, int> > dummy;
            if (put_val(x, y, digit, digit, false, dummy)) {
                a[x][y] = 0;
                moves.push(Move(x, y, digit));
            }
            else {
                a[x][y] = digit;
                d.push_back(pos);
            }
        }
    }

    while (!moves.empty()) {
        Move move = moves.top();
        moves.pop();

        vector< pair<int, int> > steps;
        put_val(move.x, move.y, move.digit, move.digit, true, steps);
        FORIT(it, steps)
            fout << it->first << " " << it->second << "\n";
    }
}

int main() {
    read();
    solve();
}
